local W, F, E, L, V, P, G = unpack(select(2, ...))

W.Utilities.Color = {}
local U = W.Utilities.Color

local format = format
local strsub = strsub

local CreateColor = CreateColor

function U.CreateColorFromTable(colorTable)
    return CreateColor(colorTable.r, colorTable.g, colorTable.b, colorTable.a)
end

function U.ExtractColorFromTable(colorTable, override)
    local r = override and override.r or colorTable.r or 1
    local g = override and override.g or colorTable.g or 1
    local b = override and override.b or colorTable.b or 1
    local a = override and override.a or colorTable.a or 1
    return r, g, b, a
end

function U.IsRGBEqual(color1, color2)
    return color1.r == color2.r and color1.g == color2.g and color1.b == color2.b
end

function U.HexToRGB(hex)
    local rhex, ghex, bhex = strsub(hex, 1, 2), strsub(hex, 3, 4), strsub(hex, 5, 6)
    return tonumber(rhex, 16) / 255, tonumber(ghex, 16) / 255, tonumber(bhex, 16) / 255
end

function U.RGBToHex(r, g, b)
    return format("%02x%02x%02x", r * 255, g * 255, b * 255)
end